from .position import Position


import copy


class Token:
    __type: str
    __value: str | int | float | dict
    __position: Position

    def __init__(self, type: str, value: str | int | float | dict, position: Position) -> None:
        self.__type = type
        self.__value = value
        self.__position = position

    @property
    def type(self) -> str:
        return copy.copy(self.__type)

    @property
    def value(self) -> str:
        return copy.copy(self.__value)

    @property
    def position(self) -> Position:
        return copy.copy(self.__position)

    def __copy__(self) -> "Token":
        return Token(copy.copy(self.__type), copy.copy(self.__value), copy.copy(self.__position))

    def __deepcopy__(self, memo: dict) -> "Token":
        return Token(copy.deepcopy(self.__type, memo), copy.deepcopy(self.__value, memo), copy.deepcopy(self.__position, memo))

    def __repl__(self) -> str:
        return f"Token({repr(self.__type)}, {repr(self.__value)}, {repr(self.__position)})"

    def __str__(self) -> str:
        return f"{self.__type} {self.__value} {self.__position}"
