import pathlib
import setuptools
import shutil
import os

if __name__ == "__main__":
    packages = ["muild"]
    install_requires = ["json5", "colored"]
    scripts = []

    readme_path = pathlib.Path(__file__).parent / "README.md"

    with readme_path.open("r") as readme_file:
        readme_content: str = readme_file.read()

    home_path = pathlib.Path.home()
    lib_path = home_path / ".local" / "lib" / "muild"

    if lib_path.exists():
        shutil.rmtree(lib_path)

    else:
        lib_path.mkdir(parents=True)

    local_path = pathlib.Path(__file__).parent
    local_lib_path = local_path / "lib"

    shutil.copytree(local_lib_path, lib_path, dirs_exist_ok=True)

    setuptools.setup(
        name="muild",
        version="2.0.2",
        description="Make file generator.",
        long_description=readme_content,
        long_description_content_type="text/markdown",
        url="https://github.com/sahdjfg/muild",
        author="maDeveloper",
        license="MIT",
        packages=packages,
        install_requires=install_requires,
        entry_points={
            "console_scripts": [
                "muild = muild.cli:main",
            ]
        },
        scripts=scripts,
        classifiers=[
            "Development Status :: 3 - Alpha",
            "Intended Audience :: Developers",
            "License :: OSI Approved :: MIT License",
            "Programming Language :: Python :: 3.9",
            "Topic :: Software Development :: Build Tools",
        ],
        python_requires=">=3.9",
    )
